commit 8db568c3c6c3ca1c540198725e7490b819167209
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Sep 21 00:17:02 2020 +0100

    libstdc++: Fix noexcept-specifier for std::bind_front [PR 97101]
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/97101
            * include/std/functional (bind_front): Fix order of parameters
            in is_nothrow_constructible_v specialization.
            * testsuite/20_util/function_objects/bind_front/97101.cc: New test.
    
    (cherry picked from commit 3c755b428e188228d0bad90625c995fd25a02322)

diff --git a/libstdc++-v3/include/std/functional b/libstdc++-v3/include/std/functional
index 2a9b2a003db..dc21c10b7ad 100644
--- a/libstdc++-v3/include/std/functional
+++ b/libstdc++-v3/include/std/functional
@@ -905,8 +905,8 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
   template<typename _Fn, typename... _Args>
     constexpr _Bind_front_t<_Fn, _Args...>
     bind_front(_Fn&& __fn, _Args&&... __args)
-    noexcept(is_nothrow_constructible_v<int, _Bind_front_t<_Fn, _Args...>,
-					_Fn, _Args...>)
+    noexcept(is_nothrow_constructible_v<_Bind_front_t<_Fn, _Args...>,
+					int, _Fn, _Args...>)
     {
       return _Bind_front_t<_Fn, _Args...>(0, std::forward<_Fn>(__fn),
 					  std::forward<_Args>(__args)...);
diff --git a/libstdc++-v3/testsuite/20_util/function_objects/bind_front/97101.cc b/libstdc++-v3/testsuite/20_util/function_objects/bind_front/97101.cc
new file mode 100644
index 00000000000..b159eb02591
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/function_objects/bind_front/97101.cc
@@ -0,0 +1,41 @@
+// Copyright (C) 2020 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++2a" }
+// { dg-do compile { target c++2a } }
+
+#include <functional>
+
+void
+test01()
+{
+  struct F1
+  {
+    void operator()() { }
+  };
+
+  struct F2
+  {
+    F2() = default;
+    F2(const F2&) noexcept(false) { }
+    void operator()() { }
+  };
+
+  // PR libstdc++/97101
+  static_assert( noexcept(std::bind_front(F1{})) );
+  static_assert( ! noexcept(std::bind_front(F2{})) );
+}

